/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.security.system.user.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.security.system.user.entity.User;
import org.security.system.user.entity.UserDept;
import org.security.system.user.vo.UserVO;
import org.springblade.core.datascope.annotation.DataAuth;
import org.springblade.core.datascope.enums.DataScopeEnum;
import org.security.system.entity.Role;
import org.security.system.user.excel.UserExcel;

import java.util.List;

/**
 * Mapper 接口
 *
 * @author Chill
 */
public interface UserMapper extends BaseMapper<User> {

	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param user
	 * @param deptIdList
	 * @param tenantId
	 * @return
	 */
	List<User> selectUserPage(IPage<User> page, @Param("user") User user, @Param("deptIdList") List<Long> deptIdList, @Param("tenantId") String tenantId);

	/**
	 * 获取用户
	 *
	 * @param tenantId
	 * @param account
	 * @return
	 */
	User getUser(String tenantId, String account);

	Role getRoleByAlias(@Param("alias")String alias);

	User userHasRoleAlias(String tenantId, Long userId, Long role);

	/**
	 * 获取导出用户数据
	 *
	 * @param queryWrapper
	 * @return
	 */
	List<UserExcel> exportUser(@Param("ew") Wrapper<User> queryWrapper);

	Role getRoleById(@Param("roleId")Long roleId);

	/**
	 * 获取用户数据
	 * @return
	 */
	@DataAuth(type = DataScopeEnum.OWN_DEPT_CHILD, column = "DEPT_ID")
	List<UserVO> userData();

	/**
	 * 删除userDept信息
	 * @param userIds 用户id
	 * @return
	 */
	boolean removeUserDept(@Param("userIds") List<String> userIds);

	/**
	 * 新增用户机构关联信息
	 * @param userDept
	 * @return
	 */
	boolean saveUserDept(@Param("userDept") UserDept userDept);


	String getDeptLevel(@Param("deptId") String deptId);

	List<User> getAimUserData(@Param("roleName") String roleName, @Param("deptId") String deptId);

	//获取子级机构id
	List<String> getChildDeptIds(@Param("deptIds") String deptIds);

	List<UserVO> getInspectionSafeRoleUser(@Param("list") List<String> list);

	String getAncestorsDepts(@Param("deptId") String deptId);

	List<UserVO> getAimWorkFilingUser(@Param("list") List<String> list, @Param("aimRoleList") List<String> aimRoleList);

	List<String> getAimRoleListIds(@Param("roleList") List<String> roleList);

	List<UserVO> getAllWorkFilingUser(@Param("list") List<String> list);
}
